{
            /~~~~~~~~~~~~~~~\
     ..~~~<  Memutar Gambar  >~~~..
            \~~~~~~~~~~~~~~~/

     contoh program untuk memutar gambar bitmap,
     sudut putaran bebas (0-360)

     Adi Nugroho
     Jurusan Fisika
     FMIPA - UGM
     Yogyakarta

     www.geocities.com/iniwebsiteku/
     sendto_adinugroho@yahoo.com

     ref: www.borland.com

     history:
         koleksi lama (2002)                                        
         11 April 2K3 -> komponen TImage diletakkan diatas TPanel
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, ExtDlgs,

  ShellAPI;

type
  TForm1 = class(TForm)
    ButtonLoad: TButton;
    ButtonSave: TButton;
    ButtonAbout: TButton;
    ButtonExit: TButton;
    SpinEdit1: TSpinEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    Panel1: TPanel;
    ImageAsli: TImage;
    Panel2: TPanel;
    ImagePutar: TImage;
    procedure ButtonLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
  private
    { Private declarations }
    BitmapAsli : TBitmap;
    BitmapPutar: TBitmap;
  public
    { Public declarations }
    procedure PutarGambar;
  end;

const      MaxPixel = 32768;          // 2^15
type       pRGBArray = ^TRGBArray;
           TRGBArray = array [0..MaxPixel-1] of TRGBTriple;
var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
// BitmapAsli dan BitmapPutar dibuat disini (sekalian!!!)
     BitmapAsli := TBitmap.Create;
     BitmapPutar := TBitmap.Create;

// cara untuk menampilkan judul pada kotak Open dan Save     
     OpenPictureDialog1.Title := 'Pilih salah satu file bertipe BMP';
     SavePictureDialog1.Title := 'Simpan gambar ...';
end;

// bebaskan !!!
procedure TForm1.FormDestroy(Sender: TObject);
begin
     BitmapAsli.Free;
     BitmapPutar.Free;
end;

procedure TForm1.ButtonLoadClick(Sender: TObject);
begin
// panggil file gambar bertipe bitmap (*.BMP)

     if OpenPictureDialog1.Execute then
     begin
           BitmapAsli.LoadFromFile (OpenPictureDialog1.FileName);

           if BitmapAsli.PixelFormat <> pf24bit then
              BitmapAsli.PixelFormat := pf24bit;

           ImageAsli.Picture.Graphic := BitmapAsli;

           // lakukan proses pemutaran gambar
           PutarGambar;
           
           // keterangan ttg gambar 
           Label1.Caption := 'Nama file = '+ OpenPictureDialog1.FileName + #13#10 +
           'Dimensi = '+ IntToStr (BitmapAsli.Width) + ' X ' + IntToStr (BitmapAsli.Height)+' piksel'+#13#10+
           'Titik putar = ('+ IntToStr (BitmapAsli.Width div 2)+' , '+ IntToStr(BitmapAsli.Height div 2) +')';
     end;
end;

// ubah nilai sudut pemutaran ...
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
     PutarGambar;
end;

// bagian utama program ini...
procedure TForm1.PutarGambar;
var  CosTheta, SinTheta,Theta  : double;
     i, iAsli, ii,
     j, jAsli, jj              : integer;
     iSumbuPutar, jSumbuPutar  : integer;
     ii_Putar, jj_Putar        : integer;
     Baris_Asli, Baris_Putar         : pRGBArray;
begin
     // samakan dimensi "asli" dengan "putar",
     // jadikan berformat pf24bit
     BitmapPutar.Width := BitmapAsli.Width;
     BitmapPutar.Height := BitmapAsli.Height;
     BitmapPutar.PixelFormat := pf24bit;

     // sumbu putar berada di titik tengah gambar asli
     // ---> sumbu putar (iSumbuPutar, jSumbuPutar)
     iSumbuPutar := BitmapAsli.Width div 2;
     jSumbuPutar := BitmapAsli.Height div 2;

     // sudut putar , ubah ke radian,
     // tanda - berarti putar ke kanan (searah jarum jam)
     Theta := - (SpinEdit1.Value) * PI / 180;
     SinTheta := sin (Theta);
     CosTheta := cos (Theta);

     // proses memutar
     // lebih cepat daripada dengan memakai Pixel...
     // (i,j) diubah ke (ii, jj) agar mendapatkan titik tengah dari koord. 
     // ---> ABCDE, maka titik tengahnya adl. C,
     //      dengan dua titik disebelah kiri, yaitu AB
     //      dan dua titik di sebelah kanan yaitu DE
     for j:= BitmapPutar.Height-1 downto 0 do
     begin
           Baris_Putar := BitmapPutar.ScanLine [j];

           jj := 2*(j-jSumbuPutar) + 1;
           
           for i:= BitmapPutar.Width-1 downto 0 do
           begin
                 ii := 2*(i-iSumbuPutar) + 1;

                 // putar, putar, putar, putar !!!
                 ii_Putar := Round (ii * CosTheta - jj * SinTheta);
                 jj_Putar := Round (ii * SinTheta + jj * CosTheta);

                 // kembalikan lagi ke koordinat gambar
                 // dan translasi dari sumbu putar ke pusat gambar
                 iAsli := (ii_Putar -1) div 2 + iSumbuPutar;
                 jAsli := (jj_Putar -1) div 2 + jSumbuPutar;

                 // pastikan (iAsli, jAsli) berada di dalam BitmapAsli !!!
                 if (iAsli >= 0) and (iAsli <= BitmapAsli.Width-1) and
                    (jAsli >= 0) and (jAsli <= BitmapAsli.Height-1)
                 then
                 begin
                       Baris_Asli     := BitmapAsli.ScanLine [jAsli];
                       Baris_Putar[i] := Baris_Asli [iAsli];
                 end
                 
                 // ...jika tidak,
                 // maka ruang yg kosong diisi dengan warna hitam (0,0,0)
                 else
                 begin
                       Baris_Putar[i].rgbtBlue  := 0;
                       Baris_Putar[i].rgbtGreen := 0;
                       Baris_Putar[i].rgbtRed   := 0;
                 end;
           end;
     end;

     // isi komponen ImagePutar dengan gambar hasil pemutaran
     ImagePutar.Picture.Graphic := BitmapPutar;
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
// properti Checked pada CheckBox1 diisi dengan TRUE !!!
     ImageAsli.Stretch := CheckBox1.Checked;
     ImagePutar.Stretch := CheckBox1.Checked;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
// ok, sudah dulu... aku mau keluar
     Application.Terminate;
end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
begin
// jika gambar hasil proses pemutaran disimpan sebagai file baru,
// maka file tsb akan terlihat "aneh" dan "hancur"
// ...
     if SavePictureDialog1.Execute then
        BitmapPutar.SaveToFile (SavePictureDialog1.FileName);
end;

procedure TForm1.ButtonAboutClick(Sender: TObject);
begin
// salah satu trik untuk membuat kotak about secara cepat dan mudah !!!
     ShellAbout (Handle,
           '   Memutar Gambar',
           '   Adi Nugroho'+#13#10+'   sendto_adinugroho@yahoo.com',
           Application.Icon.Handle);
end;

end.
